"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var classnames_1 = __importDefault(require("classnames"));
var help_1 = __importDefault(require("@amalto/help"));
var typeahead_input_1 = __importDefault(require("@amalto/typeahead-input"));
var TypeaheadFormInput = (function (_super) {
    __extends(TypeaheadFormInput, _super);
    function TypeaheadFormInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderInput = function (field) {
            var _a = _this.props, name = _a.name, containerClass = _a.containerClass, collection = _a.collection, placeholder = _a.placeholder, selectedCollectionType = _a.selectedCollectionType, collectionTypes = _a.collectionTypes, setCollectionType = _a.setCollectionType;
            var input = field.input, meta = field.meta;
            return (React.createElement("div", { className: (0, classnames_1.default)('form-group', containerClass, {
                    invalid: meta.touched && !!meta.error,
                }) },
                _this.renderLabel(),
                React.createElement(typeahead_input_1.default, { id: name, collection: collection, value: input.value, handleInputChange: input.onChange, placeholder: placeholder, selectedCollectionType: selectedCollectionType, collectionTypes: collectionTypes, setCollectionType: setCollectionType }),
                _this.renderErrorMsg(meta)));
        };
        _this.renderLabel = function () {
            var _a = _this.props, help = _a.help, label = _a.label;
            return label ? (React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help }))) : null;
        };
        _this.renderErrorMsg = function (meta) {
            var collapseErrorSpace = _this.props.collapseErrorSpace;
            if (meta.touched && !!meta.error) {
                return React.createElement("p", { className: "validation-error-message" }, meta.error);
            }
            return collapseErrorSpace ? null : (React.createElement("p", { className: "validation-error-message" }, "\u00A0"));
        };
        return _this;
    }
    TypeaheadFormInput.prototype.render = function () {
        var _a = this.props, name = _a.name, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn,
        };
        return name ? (React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, { component: this.renderInput }))) : null;
    };
    return TypeaheadFormInput;
}(React.Component));
exports.default = TypeaheadFormInput;
//# sourceMappingURL=index.js.map