import * as React from 'react';
import { BaseFieldProps } from 'redux-form';
declare namespace TypeaheadFormInput {
    interface Props extends BaseFieldProps {
        name: string;
        collection: string[];
        label?: string | JSX.Element;
        placeholder?: string;
        help?: string;
        containerClass?: string;
        collapseErrorSpace?: boolean;
        selectedCollectionType?: string;
        collectionTypes?: string[];
        setCollectionType?: (collectionType: string) => void;
        children?: React.ReactNode;
        key?: React.ReactText;
        ref?: React.Ref<TypeaheadFormInput>;
        component?: any;
        format?: any;
        normalize?: any;
        props?: any;
        parse?: any;
        validate?: any;
        warn?: any;
        withRef?: any;
    }
}
declare class TypeaheadFormInput extends React.Component<TypeaheadFormInput.Props> {
    private renderInput;
    private renderLabel;
    private renderErrorMsg;
    render(): JSX.Element;
}
export default TypeaheadFormInput;
